Subject: Re: [PATCH net v3] net: macb: remove change_mtu callback

From: Jakub Kicinski <[email-masked]>
Date: Mon, 11 Mar 2024 16:17:27 -0700

On Mon, 11 Mar 2024 16:43:15 +0100 [email-masked] wrote:
> Because it doesn't allow MTU changes when the interface is up, although
> it is not necessary.
> 
> This callback has been added to add in a first implementation of the Jumbo
> support [1],since it has been reworked and moved to the probe [2].
> 
> With this patch the core will set the MTU, regardless of if the interface
> is up or not.
> 
> [1] commit a5898ea09aad ("net: macb: Add change_mtu callback with
>     jumbo support")
> [2] commit 44770e1180de ("ethernet: use core min/max MTU checking")
> 
> Fixes: 44770e1180de ("ethernet: use core min/max MTU checking")

static void macb_init_rx_buffer_size(struct macb *bp, size_t size)
{
	if (!macb_is_gem(bp)) {
		bp->rx_buffer_size = MACB_RX_BUFFER_SIZE;
	} else {
		bp->rx_buffer_size = size;

where size is:

	size_t bufsz = dev->mtu + ETH_HLEN + ETH_FCS_LEN + NET_IP_ALIGN;

I guess you tested this on a platform where !macb_is_gem(bp) ?
Otherwise the buffer size seems to be based on MTU and the proposed
change won't be correct.
-- 
pw-bot: cr